"""Adapters around actual Fnorb stubs so they behave like the python
 mapping.

Each class does two things:
1. Inherets from the actual skel, so that the inheritence in the main code
can be uniform.

2. Defines a _this() function which creates a unique object ref for a
class object, and registers it with the boa.
"""
# import the General Adapter code
from BioCorba.Adapters.Generic import GenericFnorbAdapter

# import the actual skeleton code
import BioCorba.bsane_skel.seqcore_skel as skel_base
        
class AnonymousSequence(skel_base.AnonymousSequence_skel, 
                        GenericFnorbAdapter):
    unique_name = 'AnonymousSequence'

class SeqFeature(skel_base.SeqFeature_skel, GenericFnorbAdapter):
    unique_name = 'SeqFeature'

class SeqFeatureCollection(skel_base.SeqFeatureCollection_skel,
                           GenericFnorbAdapter):
    unique_name = 'SeqFeatureCollection'

class AnnotatableSequence(skel_base.AnnotatableSequence_skel,
                          GenericFnorbAdapter):
    unique_name = 'AnnotatableSequence'

class BioSequence(skel_base.BioSequence_skel,
                  GenericFnorbAdapter):
    unique_name = 'BioSequence'

class NucleotideSequence(skel_base.NucleotideSequence_skel, 
                         GenericFnorbAdapter):
    unique_name = 'NucleotideSequence'
